features:
  secondary:
    - name: Performance improvements
      available_in: [core, starter, premium, ultimate]
      performance_url: 'https://gitlab.com/dashboard/merge_requests?scope=all&utf8=%E2%9C%93&state=opened&label_name[]=performance&milestone_title=12.9'
      reporter: multiple
      description: |
        We are continuing to make great strides improving the performance of GitLab in every release. [We're committed](/handbook/product/#performance) to not only making individual instances of GitLab even faster, but also to greatly improving the performance of GitLab.com, an instance that has over 1 million users!

        In GitLab 12.9 we are shipping performance improvements for issues, projects, milestones, and a lot more! Some of the improvements in GitLab 12.9 are:

        - [Ensure RepositoryLinkFilter handles Gitaly failures gracefully](https://gitlab.com/gitlab-org/gitlab/-/merge_requests/26531)
        - [Search issues in GraphQl by milestone and assignees](https://gitlab.com/gitlab-org/gitlab/-/merge_requests/25794)
        - [Bulk lazy loader for epic aggregates](https://gitlab.com/gitlab-org/gitlab/-/merge_requests/23406)
        - [Fix N+1 in Group milestone view](https://gitlab.com/gitlab-org/gitlab/-/merge_requests/26051)
        - [Set upper limit on bulk API request size for Elasticsearch indexing](https://gitlab.com/gitlab-org/gitlab/-/issues/201805)
        - [Project-level code search now 10x faster when there is a large number of results](https://gitlab.com/gitlab-org/gitlab/-/issues/33562)
        - [Buffer Writes to ElasticSearch and use the Bulk API](https://gitlab.com/gitlab-org/gitlab/issues/34086)
        - [Batch load records from the database for Elasticsearch incremental bulk updates](https://gitlab.com/gitlab-org/gitlab/-/issues/207280)
        - [Request Inline or Parallel diffs instead of fetching all data from the backend in one request](https://gitlab.com/gitlab-org/gitlab/issues/33183)
        - [Introduce `BulkInsertSafe` mixin for safe bulk-inserts](https://gitlab.com/gitlab-org/gitlab/-/merge_requests/24168)
        - [Bulk insert for Import with 14-19% reduction in time](https://gitlab.com/gitlab-org/gitlab/issues/196844#note_305381280)
        - [Streaming serializer on Export with constant memory consumption](https://gitlab.com/gitlab-org/gitlab/-/issues/208803)
